### Name: stat_summary
### Title: stat_summary
### Aliases: stat_summary StatSummary
### Keywords: hplot

### ** Examples
## Not run: 
##D # Basic operation on a small dataset
##D c <- qplot(cyl, mpg, data=mtcars)
##D c + stat_summary()
##D 
##D # The simplest type of summary range takes a vector of x's and returns
##D # a single value:
##D 
##D stat_sum_single <- function(fun, geom="point", ...) {
##D   stat_summary(fun=fun, colour="red", geom=geom, size = 3, ...)      
##D }
##D 
##D c + stat_sum_single(mean)
##D c + stat_sum_single(mean, geom="line")
##D c + stat_sum_single(median)
##D c + stat_sum_single(sd)
##D 
##D # More complex summary functions operate on a data.frame, summarising
##D # the values of y for a given x (the split into separate data.frames with
##D # uniques values of x is performed automatically by stat_summary)
##D #
##D # A set of useful summary functions is provided from the Hmisc package:
##D 
##D stat_sum_df <- function(fun, geom="crossbar", ...) {
##D   stat_summary(fun=fun, colour="red", geom=geom, width=0.2, ...)
##D }
##D 
##D c + stat_sum_df("mean_cl_boot")
##D c + stat_sum_df("mean_sdl")
##D c + stat_sum_df("mean_sdl", mult=1)
##D c + stat_sum_df("median_hilow")
##D c + stat_sum_df("range", geom="linerange")
##D 
##D # There are lots of different geoms you can use to display the summaries
##D     
##D c + stat_sum_df(fun="mean_cl_normal")
##D c + stat_sum_df(fun="mean_cl_normal", geom = "errorbar")
##D c + stat_sum_df(fun="mean_cl_normal", geom = "pointrange")
##D c + stat_sum_df(fun="mean_cl_normal", geom = "smooth")
##D     
##D # Summaries are much more useful with a bigger data set:
##D m <- ggplot(movies, aes(x=round(rating), y=votes)) + geom_point()
##D (m2 <- m + stat_summary(fun="mean_cl_boot", geom="crossbar", colour="red", width=0.3))
##D # Notice how the overplotting skews off visual perception of the mean
##D # supplementing the raw data with summary statisitcs is _very_ important
##D   
##D # Next, we'll look at votes on a log scale.
##D 
##D # Transforming the scale performs the transforming before the statistic.
##D # This means we're calculating the summary on the logged data
##D m2 + scale_y_log10()
##D # Transforming the coordinate system performs the transforming after the
##D # statistic. This means we're calculating the summary on the raw data, 
##D # and stretching the geoms onto the log scale.  Compare the widths of the
##D # standard errors.
##D m2 + coord_trans(y="log10")
## End(Not run)


